#!/bin/sh
#
#  NOTE **** Most of the problems I had with fetching the d/l
#            seemed to be due to the loss of connectivity. Now
#	     that I fixed that, things seem fine.

#mydate=`date +%Y%m%d%H%M`

SNORT_INLINE=`grep "snort-inline=" /etc/packetprotector.conf | cut -d "=" -f 2`

# Moved if code down so update will occur regardless of whether snort is enabled or not
#if [ "X$SNORT_INLINE" = "X1" ] ; then
	
#	echo "Snort-inline enabled.  Continuing..."

	if [ -s /packetprotector/etc/snort/oinkcode ] ; then

		echo "Oinkcode found!"

		OINKCODE=`cat /packetprotector/etc/snort/oinkcode | sed s/" "/""/g`
		export LD_LIBRARY_PATH=/packetprotector/usr/lib

		backdoor_rule_count=200
		web_client_rule_count=250
#	Create log if wanted
#		cp -pf /packetprotector/logs/snort-update.log /packetprotector/logs/snort-update.$mydate
#		ping -c 4 192.168.3.2 > /packetprotector/logs/snort-update.log
#		nslookup www.snort.org >> /packetprotector/logs/snort-update.log

		echo "Fetching VRT rules!"
#		echo "Fetching VRT rules!" >> /packetprotector/logs/snort-update.log

		VRT_RULES=http://www.snort.org/pub-bin/oinkmaster.cgi/$OINKCODE/snortrules-snapshot-CURRENT.tar.gz

		if [ ! -d /packetprotector/tmp/oink/ ] ; then
			mkdir /packetprotector/tmp/oink
		fi
		cd /packetprotector/tmp/oink

#	Changed wget to curl		
#		wget $VRT_RULES || exit
		curl -L -s $VRT_RULES -O || exit
		tar -zxvf snortrules-snapshot-CURRENT.tar.gz rules/* > /dev/null 2> /dev/null
		echo "Rules extracted!"

		if [ -s snortrules-snapshot-CURRENT.tar.gz ] ; then
			cd rules
			cp /packetprotector/etc/snort/snort-inline.conf .
			mkdir drop-rules

			cp VRT-License.txt drop-rules/

			### setup backdoor rules
			grep -e "^alert" backdoor.rules | tail -$backdoor_rule_count | sed "s/^alert/drop/"  > drop-rules/backdoor.rules
			grep "include \$RULE_PATH/backdoor.rules" snort-inline.conf > /dev/null
			if [ $? = 0 ] ; then
				echo "backdoor.rules found in snort-inline.conf"
			else
				echo "include \$RULE_PATH/backdoor.rules" >> snort-inline.conf
			fi

			### setup web-client rules
			grep -e "^alert" web-client.rules | tail -$web_client_rule_count | sed "s/^alert/drop/"  > drop-rules/web-client.rules
			grep "include \$RULE_PATH/web-client.rules" snort-inline.conf > /dev/null
			if [ $? = 0 ] ; then
				echo "web-client.rules found in snort-inline.conf"
			else
				echo "include \$RULE_PATH/web-client.rules" >> snort-inline.conf
			fi

			# My code for updating the MTC snort ruleset at http://mtc.sri.com/live_data/signatures/
#			wget http://mtc.sri.com/live_data/signatures/ -O linkpage.html
			curl -s http://mtc.sri.com/live_data/signatures/ -o linkpage.html
			FILESIZE=`ls -l linkpage.html | awk '{print $5}'`
			if [ $FILESIZE -lt 15000 ] ; then
				echo "Failed to fetch mtc linkpage"
				return
			else
				DLLINK=`grep Ruleset.html linkpage.html | cut -d \" -f 2`
#				wget $DLLINK -O mtc-malware.rules
				curl -s $DLLINK -o mtc-malware.rules
				FILESIZE=`ls -l mtc-malware.rules | awk '{print $5}'`
				if [ $FILESIZE -gt 20000 ] ; then
					echo "Fetched mtc rules"
					### setup mtc rules
					# Next line does all rules unchanged. Bogons are too broad though.
					# grep -e "^alert" mtc-malware.rules | sed "s/^alert/drop/"  > drop-rules/mtc-malware.rules
					BOGONS2="50.0.0.0\/8,100.0.0.0\/6,104.0.0.0\/6,169.254.0.0\/16,172.16.0.0\/12,176.0.0.0\/7,179.0.0.0\/8,181.0.0.0\/8,185.0.0.0\/8"
					grep "Bogon Nets 2" mtc-malware.rules | sed "s/\[.*\]/\[$BOGONS2\]/" | sed "s/^alert/drop/" > drop-rules/mtc-malware.rules
					grep -e "^alert" mtc-malware.rules | grep -v "Bogon Nets 2" | sed "s/^alert/drop/"  >> drop-rules/mtc-malware.rules
					# End Bogon2 code
	
					grep "include \$RULE_PATH/mtc-malware.rules" snort-inline.conf > /dev/null
					if [ $? = 0 ] ; then
						echo "mtc-malware.rules found in snort-inline.conf"
					else
						echo "include \$RULE_PATH/mtc-malware.rules" >> snort-inline.conf
					fi
				fi
			fi
			# End my update code

			# My code just to copy ALL the rules so I can see/use them later
			cp -f *.rules /packetprotector/etc/snort/all-rules

			### copy to /packetprotector/etc/snort/drop-rules
			rm -rf /packetprotector/etc/snort/drop-rules.OLD
			rm -f /packetprotector/etc/snort/snort-inline.conf.OLD
			cp -r /packetprotector/etc/snort/drop-rules /packetprotector/etc/snort/drop-rules.OLD
			cp /packetprotector/etc/snort/snort-inline.conf /packetprotector/etc/snort/snort-inline.conf.OLD
			cp drop-rules/* /packetprotector/etc/snort/drop-rules
			cp snort-inline.conf /packetprotector/etc/snort/

			### test new rules
			/packetprotector/usr/sbin/snort-inline -QT -c /packetprotector/etc/snort/snort-inline.conf > /dev/null 2> /dev/null

			if [ $? = 0 ]; then
				echo "Snort test succeeded!  Rotating alert file."
#				echo "Snort test succeeded!  Rotating alert file and restarting Snort." >> /packetprotector/logs/snort-update.log
				# update timestamp
				date "+%a %b %d %H:%M:%S %Y" > /packetprotector/etc/snort/drop-rules/last_updated
			# My test
				if [ "X$SNORT_INLINE" = "X1" ] ; then
					EPOCHTIME=`date +%s`
					LOGDIR="/packetprotector/logs"
					mv $LOGDIR/snort-inline/alert $LOGDIR/snort-inline/alert.$EPOCHTIME && touch $LOGDIR/snort-inline/alert
					# restart snort
#					killall snort-inline 2> /dev/null
					killall -1 snort-inline 2> /dev/null
					echo "Snort killed! Snort will restart shortly via watchdog..."
#					echo "Snort killed! Snort will restart shortly via watchdog..." >> /packetprotector/logs/snort-update.log
					# snort will get restarted by the watchdog
#					/packetprotector/etc/init.d/S11snort-inline
					echo "Done!"
#					echo "Done!" >> /packetprotector/logs/snort-update.log
				fi
			else
				echo "Snort test failed!  Restoring old signatures."
#				echo "Snort test failed!  Restoring old signatures." >> /packetprotector/logs/snort-update.log
				rm -rf /packetprotector/etc/snort/drop-rules
				rm -f /packetprotector/etc/snort/snort-inline.conf
				mv /packetprotector/etc/snort/drop-rules.OLD /packetprotector/etc/snort/drop-rules
				mv /packetprotector/etc/snort/snort-inline.conf.OLD /packetprotector/etc/snort/snort-inline.conf
			fi
		
		else
 			echo "Error fetching rules files!"
#			echo "Error fetching rules files!" >> /packetprotector/logs/snort-update.log
		fi

		cd
		rm -rf /packetprotector/tmp/oink

	else
		echo "Oinkcode not found!"

	fi

#fi
